/* FileChanges.c generated by valac 0.55.1, the Vala compiler
 * generated from FileChanges.vala, do not modify */

/* Copyright 2019 elementary, Inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, Inc.,; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include "pantheon-files-core.h"

#define FILES_FILE_CHANGES_CONSUME_CHANGES_MAX_CHUNK 20

typedef enum  {
	FILES_FILE_CHANGES_KIND_INITIAL,
	FILES_FILE_CHANGES_KIND_ADDED,
	FILES_FILE_CHANGES_KIND_CHANGED,
	FILES_FILE_CHANGES_KIND_REMOVED,
	FILES_FILE_CHANGES_KIND_MOVED
} FilesFileChangesKind;

#define FILES_FILE_CHANGES_TYPE_KIND (files_file_changes_kind_get_type ())
typedef struct _FilesFileChangesChange FilesFileChangesChange;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _files_file_changes_change_free0(var) ((var == NULL) ? NULL : (var = (files_file_changes_change_free (var), NULL)))
#define _g_array_unref0(var) ((var == NULL) ? NULL : (var = (g_array_unref (var), NULL)))

struct _FilesFileChangesChange {
	FilesFileChangesKind kind;
	GFile* from;
	GFile* to;
};

VALA_EXTERN GQueue* files_file_changes_queue;
GQueue* files_file_changes_queue = NULL;
VALA_EXTERN GMutex files_file_changes_queue_mutex;
GMutex files_file_changes_queue_mutex = {0};

VALA_EXTERN GType files_file_changes_kind_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void files_file_changes_change_free (FilesFileChangesChange * self);
static void files_file_changes_change_instance_init (FilesFileChangesChange * self);
VALA_EXTERN FilesFileChangesChange* files_file_changes_change_new (void);
VALA_EXTERN GQueue* files_file_changes_get_queue (void);
static void _files_file_changes_change_free0_ (gpointer var);
static inline void _g_queue_free__files_file_changes_change_free0_ (GQueue* self);
VALA_EXTERN void files_file_changes_queue_add_common (FilesFileChangesChange* new_item);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void _g_array_unref0_ (gpointer var);
static inline void _g_list_free__g_array_unref0_ (GList* self);
static void _vala_GFile_free_function_content_of (gpointer data);

static GType
files_file_changes_kind_get_type_once (void)
{
	static const GEnumValue values[] = {{FILES_FILE_CHANGES_KIND_INITIAL, "FILES_FILE_CHANGES_KIND_INITIAL", "initial"}, {FILES_FILE_CHANGES_KIND_ADDED, "FILES_FILE_CHANGES_KIND_ADDED", "added"}, {FILES_FILE_CHANGES_KIND_CHANGED, "FILES_FILE_CHANGES_KIND_CHANGED", "changed"}, {FILES_FILE_CHANGES_KIND_REMOVED, "FILES_FILE_CHANGES_KIND_REMOVED", "removed"}, {FILES_FILE_CHANGES_KIND_MOVED, "FILES_FILE_CHANGES_KIND_MOVED", "moved"}, {0, NULL, NULL}};
	GType files_file_changes_kind_type_id;
	files_file_changes_kind_type_id = g_enum_register_static ("FilesFileChangesKind", values);
	return files_file_changes_kind_type_id;
}

GType
files_file_changes_kind_get_type (void)
{
	static volatile gsize files_file_changes_kind_type_id__once = 0;
	if (g_once_init_enter (&files_file_changes_kind_type_id__once)) {
		GType files_file_changes_kind_type_id;
		files_file_changes_kind_type_id = files_file_changes_kind_get_type_once ();
		g_once_init_leave (&files_file_changes_kind_type_id__once, files_file_changes_kind_type_id);
	}
	return files_file_changes_kind_type_id__once;
}

FilesFileChangesChange*
files_file_changes_change_new (void)
{
	FilesFileChangesChange* self;
	self = g_slice_new0 (FilesFileChangesChange);
	files_file_changes_change_instance_init (self);
	return self;
}

static void
files_file_changes_change_instance_init (FilesFileChangesChange * self)
{
}

void
files_file_changes_change_free (FilesFileChangesChange * self)
{
	_g_object_unref0 (self->from);
	_g_object_unref0 (self->to);
	g_slice_free (FilesFileChangesChange, self);
}

static void
_files_file_changes_change_free0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (files_file_changes_change_free (var), NULL));
}

static inline void
_g_queue_free__files_file_changes_change_free0_ (GQueue* self)
{
	g_queue_free_full (self, (GDestroyNotify) _files_file_changes_change_free0_);
}

GQueue*
files_file_changes_get_queue (void)
{
	GQueue* _tmp0_;
	GQueue* _tmp2_;
	GQueue* result;
	g_mutex_lock (&files_file_changes_queue_mutex);
	_tmp0_ = files_file_changes_queue;
	if (_tmp0_ == NULL) {
		GQueue* _tmp1_;
		_tmp1_ = g_queue_new ();
		(files_file_changes_queue == NULL) ? NULL : (files_file_changes_queue = (_g_queue_free__files_file_changes_change_free0_ (files_file_changes_queue), NULL));
		files_file_changes_queue = _tmp1_;
	}
	g_mutex_unlock (&files_file_changes_queue_mutex);
	_tmp2_ = files_file_changes_queue;
	result = _tmp2_;
	return result;
}

void
files_file_changes_queue_add_common (FilesFileChangesChange* new_item)
{
	GQueue* queue = NULL;
	GQueue* _tmp0_;
	FilesFileChangesChange* _tmp1_;
	g_return_if_fail (new_item != NULL);
	_tmp0_ = files_file_changes_get_queue ();
	queue = _tmp0_;
	g_mutex_lock (&files_file_changes_queue_mutex);
	_tmp1_ = new_item;
	new_item = NULL;
	g_queue_push_head (queue, _tmp1_);
	g_mutex_unlock (&files_file_changes_queue_mutex);
	_files_file_changes_change_free0 (new_item);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
files_file_changes_queue_file_added (GFile* location)
{
	FilesFileChangesChange* new_item = NULL;
	GFile* _tmp0_;
	FilesFileChangesChange* _tmp1_ = NULL;
	FilesFileChangesChange* _tmp2_;
	g_return_if_fail (location != NULL);
	_tmp0_ = _g_object_ref0 (location);
	_tmp1_ = files_file_changes_change_new ();
	_tmp1_->kind = FILES_FILE_CHANGES_KIND_ADDED;
	_g_object_unref0 (_tmp1_->from);
	_tmp1_->from = _tmp0_;
	new_item = _tmp1_;
	_tmp2_ = new_item;
	new_item = NULL;
	files_file_changes_queue_add_common (_tmp2_);
	_files_file_changes_change_free0 (new_item);
}

void
files_file_changes_queue_file_changed (GFile* location)
{
	FilesFileChangesChange* new_item = NULL;
	GFile* _tmp0_;
	FilesFileChangesChange* _tmp1_ = NULL;
	FilesFileChangesChange* _tmp2_;
	g_return_if_fail (location != NULL);
	_tmp0_ = _g_object_ref0 (location);
	_tmp1_ = files_file_changes_change_new ();
	_tmp1_->kind = FILES_FILE_CHANGES_KIND_CHANGED;
	_g_object_unref0 (_tmp1_->from);
	_tmp1_->from = _tmp0_;
	new_item = _tmp1_;
	_tmp2_ = new_item;
	new_item = NULL;
	files_file_changes_queue_add_common (_tmp2_);
	_files_file_changes_change_free0 (new_item);
}

void
files_file_changes_queue_file_removed (GFile* location)
{
	FilesFileChangesChange* new_item = NULL;
	GFile* _tmp0_;
	FilesFileChangesChange* _tmp1_ = NULL;
	FilesFileChangesChange* _tmp2_;
	g_return_if_fail (location != NULL);
	_tmp0_ = _g_object_ref0 (location);
	_tmp1_ = files_file_changes_change_new ();
	_tmp1_->kind = FILES_FILE_CHANGES_KIND_REMOVED;
	_g_object_unref0 (_tmp1_->from);
	_tmp1_->from = _tmp0_;
	new_item = _tmp1_;
	_tmp2_ = new_item;
	new_item = NULL;
	files_file_changes_queue_add_common (_tmp2_);
	_files_file_changes_change_free0 (new_item);
}

void
files_file_changes_queue_file_moved (GFile* from,
                                     GFile* to)
{
	FilesFileChangesChange* new_item = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	FilesFileChangesChange* _tmp2_ = NULL;
	FilesFileChangesChange* _tmp3_;
	g_return_if_fail (from != NULL);
	g_return_if_fail (to != NULL);
	_tmp0_ = _g_object_ref0 (from);
	_tmp1_ = _g_object_ref0 (to);
	_tmp2_ = files_file_changes_change_new ();
	_tmp2_->kind = FILES_FILE_CHANGES_KIND_MOVED;
	_g_object_unref0 (_tmp2_->from);
	_tmp2_->from = _tmp0_;
	_g_object_unref0 (_tmp2_->to);
	_tmp2_->to = _tmp1_;
	new_item = _tmp2_;
	_tmp3_ = new_item;
	new_item = NULL;
	files_file_changes_queue_add_common (_tmp3_);
	_files_file_changes_change_free0 (new_item);
}

static void
_g_object_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
}

static void
_g_array_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_array_unref (var), NULL));
}

static inline void
_g_list_free__g_array_unref0_ (GList* self)
{
	g_list_free_full (self, (GDestroyNotify) _g_array_unref0_);
}

static void
_vala_GFile_free_function_content_of (gpointer data)
{
	GFile* self;
	self = *((GFile**) data);
	_g_object_unref0_ (self);
}

static gpointer
_g_array_ref0 (gpointer self)
{
	return self ? g_array_ref (self) : NULL;
}

void
files_file_changes_consume_changes (gboolean consume_all)
{
	GQueue* queue = NULL;
	GQueue* _tmp0_;
	guint chunk_count = 0U;
	gboolean flush_needed = FALSE;
	GList* additions = NULL;
	GList* changes = NULL;
	GList* deletions = NULL;
	GList* moves = NULL;
	_tmp0_ = files_file_changes_get_queue ();
	queue = _tmp0_;
	additions = NULL;
	changes = NULL;
	deletions = NULL;
	moves = NULL;
	{
		gboolean _tmp1_ = FALSE;
		chunk_count = (guint) 0;
		_tmp1_ = TRUE;
		while (TRUE) {
			FilesFileChangesChange* change = NULL;
			GQueue* _tmp3_;
			gpointer _tmp4_;
			FilesFileChangesChange* _tmp5_;
			FilesFileChangesChange* _tmp27_;
			FilesFileChangesChange* _tmp28_;
			if (!_tmp1_) {
				guint _tmp2_;
				_tmp2_ = chunk_count;
				chunk_count = _tmp2_ + 1;
			}
			_tmp1_ = FALSE;
			g_mutex_lock (&files_file_changes_queue_mutex);
			_tmp3_ = queue;
			_tmp4_ = g_queue_pop_tail (_tmp3_);
			change = (FilesFileChangesChange*) _tmp4_;
			g_mutex_unlock (&files_file_changes_queue_mutex);
			_tmp5_ = change;
			if (_tmp5_ == NULL) {
				flush_needed = TRUE;
			} else {
				gboolean _tmp6_ = FALSE;
				GList* _tmp7_;
				gboolean _tmp9_ = FALSE;
				GList* _tmp10_;
				gboolean _tmp12_ = FALSE;
				GList* _tmp13_;
				gboolean _tmp15_ = FALSE;
				GList* _tmp16_;
				gboolean _tmp18_ = FALSE;
				_tmp7_ = additions;
				if (_tmp7_ != NULL) {
					FilesFileChangesChange* _tmp8_;
					_tmp8_ = change;
					_tmp6_ = _tmp8_->kind != FILES_FILE_CHANGES_KIND_ADDED;
				} else {
					_tmp6_ = FALSE;
				}
				flush_needed = _tmp6_;
				_tmp10_ = changes;
				if (_tmp10_ != NULL) {
					FilesFileChangesChange* _tmp11_;
					_tmp11_ = change;
					_tmp9_ = _tmp11_->kind != FILES_FILE_CHANGES_KIND_CHANGED;
				} else {
					_tmp9_ = FALSE;
				}
				flush_needed |= _tmp9_;
				_tmp13_ = moves;
				if (_tmp13_ != NULL) {
					FilesFileChangesChange* _tmp14_;
					_tmp14_ = change;
					_tmp12_ = _tmp14_->kind != FILES_FILE_CHANGES_KIND_MOVED;
				} else {
					_tmp12_ = FALSE;
				}
				flush_needed |= _tmp12_;
				_tmp16_ = deletions;
				if (_tmp16_ != NULL) {
					FilesFileChangesChange* _tmp17_;
					_tmp17_ = change;
					_tmp15_ = _tmp17_->kind != FILES_FILE_CHANGES_KIND_REMOVED;
				} else {
					_tmp15_ = FALSE;
				}
				flush_needed |= _tmp15_;
				if (!consume_all) {
					_tmp18_ = chunk_count >= ((guint) FILES_FILE_CHANGES_CONSUME_CHANGES_MAX_CHUNK);
				} else {
					_tmp18_ = FALSE;
				}
				flush_needed |= _tmp18_;
			}
			if (flush_needed) {
				GList* _tmp19_;
				GList* _tmp21_;
				GList* _tmp23_;
				GList* _tmp25_;
				_tmp19_ = deletions;
				if (_tmp19_ != NULL) {
					GList* _tmp20_;
					deletions = g_list_reverse (deletions);
					_tmp20_ = deletions;
					files_directory_notify_files_removed (_tmp20_);
					(deletions == NULL) ? NULL : (deletions = (_g_list_free__g_object_unref0_ (deletions), NULL));
					deletions = NULL;
				}
				_tmp21_ = moves;
				if (_tmp21_ != NULL) {
					GList* _tmp22_;
					moves = g_list_reverse (moves);
					_tmp22_ = moves;
					files_directory_notify_files_moved (_tmp22_);
					(moves == NULL) ? NULL : (moves = (_g_list_free__g_array_unref0_ (moves), NULL));
					moves = NULL;
				}
				_tmp23_ = additions;
				if (_tmp23_ != NULL) {
					GList* _tmp24_;
					additions = g_list_reverse (additions);
					_tmp24_ = additions;
					files_directory_notify_files_added (_tmp24_);
					(additions == NULL) ? NULL : (additions = (_g_list_free__g_object_unref0_ (additions), NULL));
					additions = NULL;
				}
				_tmp25_ = changes;
				if (_tmp25_ != NULL) {
					GList* _tmp26_;
					changes = g_list_reverse (changes);
					_tmp26_ = changes;
					files_directory_notify_files_changed (_tmp26_);
					(changes == NULL) ? NULL : (changes = (_g_list_free__g_object_unref0_ (changes), NULL));
					changes = NULL;
				}
			}
			_tmp27_ = change;
			if (_tmp27_ == NULL) {
				_files_file_changes_change_free0 (change);
				(moves == NULL) ? NULL : (moves = (_g_list_free__g_array_unref0_ (moves), NULL));
				(deletions == NULL) ? NULL : (deletions = (_g_list_free__g_object_unref0_ (deletions), NULL));
				(changes == NULL) ? NULL : (changes = (_g_list_free__g_object_unref0_ (changes), NULL));
				(additions == NULL) ? NULL : (additions = (_g_list_free__g_object_unref0_ (additions), NULL));
				return;
			}
			_tmp28_ = change;
			switch (_tmp28_->kind) {
				case FILES_FILE_CHANGES_KIND_ADDED:
				{
					GList* _tmp29_;
					FilesFileChangesChange* _tmp30_;
					GFile* _tmp31_;
					GFile* _tmp32_;
					_tmp29_ = additions;
					if (_tmp29_ == NULL) {
						(additions == NULL) ? NULL : (additions = (_g_list_free__g_object_unref0_ (additions), NULL));
						additions = NULL;
					}
					_tmp30_ = change;
					_tmp31_ = _tmp30_->from;
					_tmp32_ = _g_object_ref0 (_tmp31_);
					additions = g_list_prepend (additions, _tmp32_);
					break;
				}
				case FILES_FILE_CHANGES_KIND_CHANGED:
				{
					GList* _tmp33_;
					FilesFileChangesChange* _tmp34_;
					GFile* _tmp35_;
					GFile* _tmp36_;
					_tmp33_ = changes;
					if (_tmp33_ == NULL) {
						(changes == NULL) ? NULL : (changes = (_g_list_free__g_object_unref0_ (changes), NULL));
						changes = NULL;
					}
					_tmp34_ = change;
					_tmp35_ = _tmp34_->from;
					_tmp36_ = _g_object_ref0 (_tmp35_);
					changes = g_list_prepend (changes, _tmp36_);
					break;
				}
				case FILES_FILE_CHANGES_KIND_REMOVED:
				{
					GList* _tmp37_;
					FilesFileChangesChange* _tmp38_;
					GFile* _tmp39_;
					GFile* _tmp40_;
					_tmp37_ = deletions;
					if (_tmp37_ == NULL) {
						(deletions == NULL) ? NULL : (deletions = (_g_list_free__g_object_unref0_ (deletions), NULL));
						deletions = NULL;
					}
					_tmp38_ = change;
					_tmp39_ = _tmp38_->from;
					_tmp40_ = _g_object_ref0 (_tmp39_);
					deletions = g_list_prepend (deletions, _tmp40_);
					break;
				}
				case FILES_FILE_CHANGES_KIND_MOVED:
				{
					GList* _tmp41_;
					GArray* pair = NULL;
					GArray* _tmp42_;
					GArray* _tmp43_;
					FilesFileChangesChange* _tmp44_;
					GFile* _tmp45_;
					GFile* _tmp46_;
					GArray* _tmp47_;
					FilesFileChangesChange* _tmp48_;
					GFile* _tmp49_;
					GFile* _tmp50_;
					GArray* _tmp51_;
					GArray* _tmp52_;
					_tmp41_ = moves;
					if (_tmp41_ == NULL) {
						(moves == NULL) ? NULL : (moves = (_g_list_free__g_array_unref0_ (moves), NULL));
						moves = NULL;
					}
					_tmp42_ = g_array_sized_new (FALSE, FALSE, sizeof (GFile*), (guint) 2);
					g_array_set_clear_func (_tmp42_, (GDestroyNotify) _vala_GFile_free_function_content_of);
					pair = _tmp42_;
					_tmp43_ = pair;
					_tmp44_ = change;
					_tmp45_ = _tmp44_->from;
					_tmp46_ = _g_object_ref0 (_tmp45_);
					g_array_append_val (_tmp43_, _tmp46_);
					_tmp47_ = pair;
					_tmp48_ = change;
					_tmp49_ = _tmp48_->to;
					_tmp50_ = _g_object_ref0 (_tmp49_);
					g_array_append_val (_tmp47_, _tmp50_);
					_tmp51_ = pair;
					_tmp52_ = _g_array_ref0 (_tmp51_);
					moves = g_list_prepend (moves, _tmp52_);
					_g_array_unref0 (pair);
					break;
				}
				default:
				{
					g_assert_not_reached ();
				}
			}
			_files_file_changes_change_free0 (change);
		}
	}
}

