/* SidebarListInterface.c generated by valac 0.55.1, the Vala compiler
 * generated from SidebarListInterface.vala, do not modify */

/*
 * SidebarListInterface.vala
 *
 * Copyright 2020 elementary LLC. <https://elementary.io>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 *
 * Authors : Jeremy Wootten <jeremy@elementaryos.org>
 */

#include "pantheon-files-core.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

static void sidebar_sidebar_list_interface_real_open_item (SidebarSidebarListInterface* self,
                                                    SidebarSidebarItemInterface* item,
                                                    FilesOpenFlag flag);
static void sidebar_sidebar_list_interface_real_refresh_info (SidebarSidebarListInterface* self);
static guint32 sidebar_sidebar_list_interface_real_add_plugin_item (SidebarSidebarListInterface* self,
                                                             FilesSidebarPluginItem* plugin_item);
static void sidebar_sidebar_list_interface_real_clear (SidebarSidebarListInterface* self);
static void sidebar_sidebar_list_interface_real_rename_bookmark_by_uri (SidebarSidebarListInterface* self,
                                                                 const gchar* uri,
                                                                 const gchar* new_name);
static void sidebar_sidebar_list_interface_real_remove_bookmark_by_uri (SidebarSidebarListInterface* self,
                                                                 const gchar* uri);
static gboolean sidebar_sidebar_list_interface_real_has_uri (SidebarSidebarListInterface* self,
                                                      const gchar* uri,
                                                      SidebarSidebarItemInterface** row);
static gboolean sidebar_sidebar_list_interface_real_select_uri (SidebarSidebarListInterface* self,
                                                         const gchar* uri);
static gboolean sidebar_sidebar_list_interface_real_remove_item_by_id (SidebarSidebarListInterface* self,
                                                                guint32 id);
static gboolean sidebar_sidebar_list_interface_real_add_favorite (SidebarSidebarListInterface* self,
                                                           const gchar* uri,
                                                           const gchar* label,
                                                           gint index);
static SidebarSidebarItemInterface* sidebar_sidebar_list_interface_real_get_item_at_index (SidebarSidebarListInterface* self,
                                                                                    gint index);
static gboolean sidebar_sidebar_list_interface_real_move_item_after (SidebarSidebarListInterface* self,
                                                              SidebarSidebarItemInterface* item,
                                                              gint target_index);
static gboolean sidebar_sidebar_list_interface_real_is_drop_target (SidebarSidebarListInterface* self);
static GType sidebar_sidebar_list_interface_get_type_once (void);

void
sidebar_sidebar_list_interface_select_item (SidebarSidebarListInterface* self,
                                            SidebarSidebarItemInterface* item)
{
	SidebarSidebarListInterfaceIface* _iface_;
	g_return_if_fail (self != NULL);
	_iface_ = SIDEBAR_SIDEBAR_LIST_INTERFACE_GET_INTERFACE (self);
	if (_iface_->select_item) {
		_iface_->select_item (self, item);
	}
}

void
sidebar_sidebar_list_interface_unselect_all_items (SidebarSidebarListInterface* self)
{
	SidebarSidebarListInterfaceIface* _iface_;
	g_return_if_fail (self != NULL);
	_iface_ = SIDEBAR_SIDEBAR_LIST_INTERFACE_GET_INTERFACE (self);
	if (_iface_->unselect_all_items) {
		_iface_->unselect_all_items (self);
	}
}

static void
sidebar_sidebar_list_interface_real_open_item (SidebarSidebarListInterface* self,
                                               SidebarSidebarItemInterface* item,
                                               FilesOpenFlag flag)
{
	FilesSidebarInterface* _tmp0_;
	FilesSidebarInterface* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	g_return_if_fail (item != NULL);
	_tmp0_ = sidebar_sidebar_list_interface_get_sidebar (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = sidebar_sidebar_item_interface_get_uri (item);
	_tmp3_ = _tmp2_;
	g_signal_emit_by_name (_tmp1_, "path-change-request", _tmp3_, flag);
}

void
sidebar_sidebar_list_interface_open_item (SidebarSidebarListInterface* self,
                                          SidebarSidebarItemInterface* item,
                                          FilesOpenFlag flag)
{
	SidebarSidebarListInterfaceIface* _iface_;
	g_return_if_fail (self != NULL);
	_iface_ = SIDEBAR_SIDEBAR_LIST_INTERFACE_GET_INTERFACE (self);
	if (_iface_->open_item) {
		_iface_->open_item (self, item, flag);
	}
}

void
sidebar_sidebar_list_interface_refresh (SidebarSidebarListInterface* self)
{
	SidebarSidebarListInterfaceIface* _iface_;
	g_return_if_fail (self != NULL);
	_iface_ = SIDEBAR_SIDEBAR_LIST_INTERFACE_GET_INTERFACE (self);
	if (_iface_->refresh) {
		_iface_->refresh (self);
	}
}

static void
sidebar_sidebar_list_interface_real_refresh_info (SidebarSidebarListInterface* self)
{
}

void
sidebar_sidebar_list_interface_refresh_info (SidebarSidebarListInterface* self)
{
	SidebarSidebarListInterfaceIface* _iface_;
	g_return_if_fail (self != NULL);
	_iface_ = SIDEBAR_SIDEBAR_LIST_INTERFACE_GET_INTERFACE (self);
	if (_iface_->refresh_info) {
		_iface_->refresh_info (self);
	}
}

static guint32
sidebar_sidebar_list_interface_real_add_plugin_item (SidebarSidebarListInterface* self,
                                                     FilesSidebarPluginItem* plugin_item)
{
	guint32 result;
	g_return_val_if_fail (plugin_item != NULL, 0U);
	result = (guint32) 0;
	return result;
}

guint32
sidebar_sidebar_list_interface_add_plugin_item (SidebarSidebarListInterface* self,
                                                FilesSidebarPluginItem* plugin_item)
{
	SidebarSidebarListInterfaceIface* _iface_;
	g_return_val_if_fail (self != NULL, 0U);
	_iface_ = SIDEBAR_SIDEBAR_LIST_INTERFACE_GET_INTERFACE (self);
	if (_iface_->add_plugin_item) {
		return _iface_->add_plugin_item (self, plugin_item);
	}
	return 0U;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
sidebar_sidebar_list_interface_real_clear (SidebarSidebarListInterface* self)
{
	GList* _tmp0_;
	_tmp0_ = gtk_container_get_children ((GtkContainer*) self);
	{
		GList* child_collection = NULL;
		GList* child_it = NULL;
		child_collection = _tmp0_;
		for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
			GtkWidget* _tmp1_;
			GtkWidget* child = NULL;
			_tmp1_ = _g_object_ref0 ((GtkWidget*) child_it->data);
			child = _tmp1_;
			{
				GtkWidget* _tmp2_;
				GtkWidget* _tmp3_;
				_tmp2_ = child;
				gtk_container_remove ((GtkContainer*) self, _tmp2_);
				_tmp3_ = child;
				if (SIDEBAR_IS_SIDEBAR_ITEM_INTERFACE (_tmp3_)) {
					GtkWidget* _tmp4_;
					_tmp4_ = child;
					sidebar_sidebar_item_interface_destroy_bookmark (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, SIDEBAR_TYPE_SIDEBAR_ITEM_INTERFACE, SidebarSidebarItemInterface));
				}
				_g_object_unref0 (child);
			}
		}
		(child_collection == NULL) ? NULL : (child_collection = (g_list_free (child_collection), NULL));
	}
}

void
sidebar_sidebar_list_interface_clear (SidebarSidebarListInterface* self)
{
	SidebarSidebarListInterfaceIface* _iface_;
	g_return_if_fail (self != NULL);
	_iface_ = SIDEBAR_SIDEBAR_LIST_INTERFACE_GET_INTERFACE (self);
	if (_iface_->clear) {
		_iface_->clear (self);
	}
}

static void
sidebar_sidebar_list_interface_real_rename_bookmark_by_uri (SidebarSidebarListInterface* self,
                                                            const gchar* uri,
                                                            const gchar* new_name)
{
	g_return_if_fail (uri != NULL);
	g_return_if_fail (new_name != NULL);
}

void
sidebar_sidebar_list_interface_rename_bookmark_by_uri (SidebarSidebarListInterface* self,
                                                       const gchar* uri,
                                                       const gchar* new_name)
{
	SidebarSidebarListInterfaceIface* _iface_;
	g_return_if_fail (self != NULL);
	_iface_ = SIDEBAR_SIDEBAR_LIST_INTERFACE_GET_INTERFACE (self);
	if (_iface_->rename_bookmark_by_uri) {
		_iface_->rename_bookmark_by_uri (self, uri, new_name);
	}
}

static void
sidebar_sidebar_list_interface_real_remove_bookmark_by_uri (SidebarSidebarListInterface* self,
                                                            const gchar* uri)
{
	SidebarSidebarItemInterface* row = NULL;
	SidebarSidebarItemInterface* _tmp0_ = NULL;
	gboolean _tmp1_;
	SidebarSidebarItemInterface* _tmp2_;
	g_return_if_fail (uri != NULL);
	row = NULL;
	_tmp1_ = sidebar_sidebar_list_interface_has_uri (self, uri, &_tmp0_);
	_g_object_unref0 (row);
	_tmp2_ = _g_object_ref0 (_tmp0_);
	row = _tmp2_;
	if (_tmp1_) {
		SidebarSidebarItemInterface* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
		SidebarSidebarItemInterface* _tmp6_;
		SidebarSidebarItemInterface* _tmp7_;
		_tmp3_ = row;
		_tmp4_ = sidebar_sidebar_item_interface_get_permanent (_tmp3_);
		_tmp5_ = _tmp4_;
		if (_tmp5_) {
			_g_object_unref0 (row);
			return;
		}
		_tmp6_ = row;
		gtk_container_remove ((GtkContainer*) self, (GtkWidget*) _tmp6_);
		_tmp7_ = row;
		sidebar_sidebar_item_interface_destroy_bookmark (_tmp7_);
	}
	_g_object_unref0 (row);
}

void
sidebar_sidebar_list_interface_remove_bookmark_by_uri (SidebarSidebarListInterface* self,
                                                       const gchar* uri)
{
	SidebarSidebarListInterfaceIface* _iface_;
	g_return_if_fail (self != NULL);
	_iface_ = SIDEBAR_SIDEBAR_LIST_INTERFACE_GET_INTERFACE (self);
	if (_iface_->remove_bookmark_by_uri) {
		_iface_->remove_bookmark_by_uri (self, uri);
	}
}

static gboolean
sidebar_sidebar_list_interface_real_has_uri (SidebarSidebarListInterface* self,
                                             const gchar* uri,
                                             SidebarSidebarItemInterface** row)
{
	SidebarSidebarItemInterface* _vala_row = NULL;
	GList* _tmp0_;
	gboolean result;
	g_return_val_if_fail (uri != NULL, FALSE);
	_vala_row = NULL;
	_tmp0_ = gtk_container_get_children ((GtkContainer*) self);
	{
		GList* child_collection = NULL;
		GList* child_it = NULL;
		child_collection = _tmp0_;
		for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
			GtkWidget* child = NULL;
			child = (GtkWidget*) child_it->data;
			{
				GtkWidget* _tmp1_;
				_tmp1_ = child;
				if (SIDEBAR_IS_SIDEBAR_ITEM_INTERFACE (_tmp1_)) {
					GtkWidget* _tmp2_;
					const gchar* _tmp3_;
					const gchar* _tmp4_;
					_tmp2_ = child;
					_tmp3_ = sidebar_sidebar_item_interface_get_uri (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, SIDEBAR_TYPE_SIDEBAR_ITEM_INTERFACE, SidebarSidebarItemInterface));
					_tmp4_ = _tmp3_;
					if (g_strcmp0 (_tmp4_, uri) == 0) {
						GtkWidget* _tmp5_;
						_tmp5_ = child;
						_vala_row = G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, SIDEBAR_TYPE_SIDEBAR_ITEM_INTERFACE, SidebarSidebarItemInterface);
						result = TRUE;
						(child_collection == NULL) ? NULL : (child_collection = (g_list_free (child_collection), NULL));
						if (row) {
							*row = _vala_row;
						}
						return result;
					}
				}
			}
		}
		(child_collection == NULL) ? NULL : (child_collection = (g_list_free (child_collection), NULL));
	}
	result = FALSE;
	if (row) {
		*row = _vala_row;
	}
	return result;
}

gboolean
sidebar_sidebar_list_interface_has_uri (SidebarSidebarListInterface* self,
                                        const gchar* uri,
                                        SidebarSidebarItemInterface** row)
{
	SidebarSidebarListInterfaceIface* _iface_;
	g_return_val_if_fail (self != NULL, FALSE);
	_iface_ = SIDEBAR_SIDEBAR_LIST_INTERFACE_GET_INTERFACE (self);
	if (_iface_->has_uri) {
		return _iface_->has_uri (self, uri, row);
	}
	return FALSE;
}

static gboolean
sidebar_sidebar_list_interface_real_select_uri (SidebarSidebarListInterface* self,
                                                const gchar* uri)
{
	SidebarSidebarItemInterface* row = NULL;
	SidebarSidebarItemInterface* _tmp0_ = NULL;
	gboolean _tmp1_;
	SidebarSidebarItemInterface* _tmp2_;
	gboolean result;
	g_return_val_if_fail (uri != NULL, FALSE);
	sidebar_sidebar_list_interface_unselect_all_items (self);
	row = NULL;
	_tmp1_ = sidebar_sidebar_list_interface_has_uri (self, uri, &_tmp0_);
	_g_object_unref0 (row);
	_tmp2_ = _g_object_ref0 (_tmp0_);
	row = _tmp2_;
	if (_tmp1_) {
		SidebarSidebarItemInterface* _tmp3_;
		_tmp3_ = row;
		sidebar_sidebar_list_interface_select_item (self, _tmp3_);
		result = TRUE;
		_g_object_unref0 (row);
		return result;
	}
	result = FALSE;
	_g_object_unref0 (row);
	return result;
}

gboolean
sidebar_sidebar_list_interface_select_uri (SidebarSidebarListInterface* self,
                                           const gchar* uri)
{
	SidebarSidebarListInterfaceIface* _iface_;
	g_return_val_if_fail (self != NULL, FALSE);
	_iface_ = SIDEBAR_SIDEBAR_LIST_INTERFACE_GET_INTERFACE (self);
	if (_iface_->select_uri) {
		return _iface_->select_uri (self, uri);
	}
	return FALSE;
}

static gboolean
sidebar_sidebar_list_interface_real_remove_item_by_id (SidebarSidebarListInterface* self,
                                                       guint32 id)
{
	GList* _tmp0_;
	gboolean result;
	_tmp0_ = gtk_container_get_children ((GtkContainer*) self);
	{
		GList* child_collection = NULL;
		GList* child_it = NULL;
		child_collection = _tmp0_;
		for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
			GtkWidget* _tmp1_;
			GtkWidget* child = NULL;
			_tmp1_ = _g_object_ref0 ((GtkWidget*) child_it->data);
			child = _tmp1_;
			{
				GtkWidget* _tmp2_;
				_tmp2_ = child;
				if (SIDEBAR_IS_SIDEBAR_ITEM_INTERFACE (_tmp2_)) {
					SidebarSidebarItemInterface* row = NULL;
					GtkWidget* _tmp3_;
					SidebarSidebarItemInterface* _tmp4_;
					gboolean _tmp5_;
					gboolean _tmp6_;
					SidebarSidebarItemInterface* _tmp7_;
					guint32 _tmp8_;
					guint32 _tmp9_;
					_tmp3_ = child;
					row = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, SIDEBAR_TYPE_SIDEBAR_ITEM_INTERFACE, SidebarSidebarItemInterface);
					_tmp4_ = row;
					_tmp5_ = sidebar_sidebar_item_interface_get_permanent (_tmp4_);
					_tmp6_ = _tmp5_;
					if (_tmp6_) {
						_g_object_unref0 (child);
						continue;
					}
					_tmp7_ = row;
					_tmp8_ = sidebar_sidebar_item_interface_get_id (_tmp7_);
					_tmp9_ = _tmp8_;
					if (_tmp9_ == id) {
						SidebarSidebarItemInterface* _tmp10_;
						SidebarSidebarItemInterface* _tmp11_;
						_tmp10_ = row;
						gtk_container_remove ((GtkContainer*) self, (GtkWidget*) _tmp10_);
						_tmp11_ = row;
						sidebar_sidebar_item_interface_destroy_bookmark (_tmp11_);
						result = TRUE;
						_g_object_unref0 (child);
						(child_collection == NULL) ? NULL : (child_collection = (g_list_free (child_collection), NULL));
						return result;
					}
				}
				_g_object_unref0 (child);
			}
		}
		(child_collection == NULL) ? NULL : (child_collection = (g_list_free (child_collection), NULL));
	}
	result = FALSE;
	return result;
}

gboolean
sidebar_sidebar_list_interface_remove_item_by_id (SidebarSidebarListInterface* self,
                                                  guint32 id)
{
	SidebarSidebarListInterfaceIface* _iface_;
	g_return_val_if_fail (self != NULL, FALSE);
	_iface_ = SIDEBAR_SIDEBAR_LIST_INTERFACE_GET_INTERFACE (self);
	if (_iface_->remove_item_by_id) {
		return _iface_->remove_item_by_id (self, id);
	}
	return FALSE;
}

static gboolean
sidebar_sidebar_list_interface_real_add_favorite (SidebarSidebarListInterface* self,
                                                  const gchar* uri,
                                                  const gchar* label,
                                                  gint index)
{
	gboolean result;
	g_return_val_if_fail (uri != NULL, FALSE);
	g_return_val_if_fail (label != NULL, FALSE);
	result = FALSE;
	return result;
}

gboolean
sidebar_sidebar_list_interface_add_favorite (SidebarSidebarListInterface* self,
                                             const gchar* uri,
                                             const gchar* label,
                                             gint index)
{
	SidebarSidebarListInterfaceIface* _iface_;
	g_return_val_if_fail (self != NULL, FALSE);
	_iface_ = SIDEBAR_SIDEBAR_LIST_INTERFACE_GET_INTERFACE (self);
	if (_iface_->add_favorite) {
		return _iface_->add_favorite (self, uri, label, index);
	}
	return FALSE;
}

static SidebarSidebarItemInterface*
sidebar_sidebar_list_interface_real_get_item_at_index (SidebarSidebarListInterface* self,
                                                       gint index)
{
	SidebarSidebarItemInterface* result;
	result = NULL;
	return result;
}

SidebarSidebarItemInterface*
sidebar_sidebar_list_interface_get_item_at_index (SidebarSidebarListInterface* self,
                                                  gint index)
{
	SidebarSidebarListInterfaceIface* _iface_;
	g_return_val_if_fail (self != NULL, NULL);
	_iface_ = SIDEBAR_SIDEBAR_LIST_INTERFACE_GET_INTERFACE (self);
	if (_iface_->get_item_at_index) {
		return _iface_->get_item_at_index (self, index);
	}
	return NULL;
}

static gboolean
sidebar_sidebar_list_interface_real_move_item_after (SidebarSidebarListInterface* self,
                                                     SidebarSidebarItemInterface* item,
                                                     gint target_index)
{
	gboolean result;
	g_return_val_if_fail (item != NULL, FALSE);
	result = FALSE;
	return result;
}

gboolean
sidebar_sidebar_list_interface_move_item_after (SidebarSidebarListInterface* self,
                                                SidebarSidebarItemInterface* item,
                                                gint target_index)
{
	SidebarSidebarListInterfaceIface* _iface_;
	g_return_val_if_fail (self != NULL, FALSE);
	_iface_ = SIDEBAR_SIDEBAR_LIST_INTERFACE_GET_INTERFACE (self);
	if (_iface_->move_item_after) {
		return _iface_->move_item_after (self, item, target_index);
	}
	return FALSE;
}

static gboolean
sidebar_sidebar_list_interface_real_is_drop_target (SidebarSidebarListInterface* self)
{
	gboolean result;
	result = FALSE;
	return result;
}

gboolean
sidebar_sidebar_list_interface_is_drop_target (SidebarSidebarListInterface* self)
{
	SidebarSidebarListInterfaceIface* _iface_;
	g_return_val_if_fail (self != NULL, FALSE);
	_iface_ = SIDEBAR_SIDEBAR_LIST_INTERFACE_GET_INTERFACE (self);
	if (_iface_->is_drop_target) {
		return _iface_->is_drop_target (self);
	}
	return FALSE;
}

FilesSidebarInterface*
sidebar_sidebar_list_interface_get_sidebar (SidebarSidebarListInterface* self)
{
	SidebarSidebarListInterfaceIface* _iface_;
	g_return_val_if_fail (self != NULL, NULL);
	_iface_ = SIDEBAR_SIDEBAR_LIST_INTERFACE_GET_INTERFACE (self);
	if (_iface_->get_sidebar) {
		return _iface_->get_sidebar (self);
	}
	return NULL;
}

void
sidebar_sidebar_list_interface_set_sidebar (SidebarSidebarListInterface* self,
                                            FilesSidebarInterface* value)
{
	SidebarSidebarListInterfaceIface* _iface_;
	g_return_if_fail (self != NULL);
	_iface_ = SIDEBAR_SIDEBAR_LIST_INTERFACE_GET_INTERFACE (self);
	if (_iface_->set_sidebar) {
		_iface_->set_sidebar (self, value);
	}
}

static void
sidebar_sidebar_list_interface_default_init (SidebarSidebarListInterfaceIface * iface,
                                             gpointer iface_data)
{
	g_object_interface_install_property (iface, g_param_spec_object ("sidebar", "sidebar", "sidebar", FILES_TYPE_SIDEBAR_INTERFACE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	iface->open_item = sidebar_sidebar_list_interface_real_open_item;
	iface->refresh_info = sidebar_sidebar_list_interface_real_refresh_info;
	iface->add_plugin_item = sidebar_sidebar_list_interface_real_add_plugin_item;
	iface->clear = sidebar_sidebar_list_interface_real_clear;
	iface->rename_bookmark_by_uri = sidebar_sidebar_list_interface_real_rename_bookmark_by_uri;
	iface->remove_bookmark_by_uri = sidebar_sidebar_list_interface_real_remove_bookmark_by_uri;
	iface->has_uri = sidebar_sidebar_list_interface_real_has_uri;
	iface->select_uri = sidebar_sidebar_list_interface_real_select_uri;
	iface->remove_item_by_id = sidebar_sidebar_list_interface_real_remove_item_by_id;
	iface->add_favorite = sidebar_sidebar_list_interface_real_add_favorite;
	iface->get_item_at_index = sidebar_sidebar_list_interface_real_get_item_at_index;
	iface->move_item_after = sidebar_sidebar_list_interface_real_move_item_after;
	iface->is_drop_target = sidebar_sidebar_list_interface_real_is_drop_target;
}

static GType
sidebar_sidebar_list_interface_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SidebarSidebarListInterfaceIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sidebar_sidebar_list_interface_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType sidebar_sidebar_list_interface_type_id;
	sidebar_sidebar_list_interface_type_id = g_type_register_static (G_TYPE_INTERFACE, "SidebarSidebarListInterface", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (sidebar_sidebar_list_interface_type_id, gtk_container_get_type ());
	return sidebar_sidebar_list_interface_type_id;
}

GType
sidebar_sidebar_list_interface_get_type (void)
{
	static volatile gsize sidebar_sidebar_list_interface_type_id__once = 0;
	if (g_once_init_enter (&sidebar_sidebar_list_interface_type_id__once)) {
		GType sidebar_sidebar_list_interface_type_id;
		sidebar_sidebar_list_interface_type_id = sidebar_sidebar_list_interface_get_type_once ();
		g_once_init_leave (&sidebar_sidebar_list_interface_type_id__once, sidebar_sidebar_list_interface_type_id);
	}
	return sidebar_sidebar_list_interface_type_id__once;
}

