/* PermissionButton.c generated by valac 0.55.1, the Vala compiler
 * generated from PermissionButton.vala, do not modify */

/*
* Copyright (c) 2016-2018 elementary LLC. <https://elementary.io>
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation, Inc.,; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1335 USA.
*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <sys/types.h>
#include <glib.h>
#include <sys/stat.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_PERMISSION_BUTTON (permission_button_get_type ())
#define PERMISSION_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PERMISSION_BUTTON, PermissionButton))
#define PERMISSION_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PERMISSION_BUTTON, PermissionButtonClass))
#define IS_PERMISSION_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PERMISSION_BUTTON))
#define IS_PERMISSION_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PERMISSION_BUTTON))
#define PERMISSION_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PERMISSION_BUTTON, PermissionButtonClass))

typedef struct _PermissionButton PermissionButton;
typedef struct _PermissionButtonClass PermissionButtonClass;
typedef struct _PermissionButtonPrivate PermissionButtonPrivate;
typedef enum  {
	PERMISSIONS_TYPE_USER,
	PERMISSIONS_TYPE_GROUP,
	PERMISSIONS_TYPE_OTHER
} PermissionsType;

#define PERMISSIONS_TYPE_TYPE (permissions_type_get_type ())
enum  {
	PERMISSION_BUTTON_0_PROPERTY,
	PERMISSION_BUTTON_PERMISSION_TYPE_PROPERTY,
	PERMISSION_BUTTON_NUM_PROPERTIES
};
static GParamSpec* permission_button_properties[PERMISSION_BUTTON_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef enum  {
	PERMISSIONS_VALUE_READ,
	PERMISSIONS_VALUE_WRITE,
	PERMISSIONS_VALUE_EXE
} PermissionsValue;

#define PERMISSIONS_TYPE_VALUE (permissions_value_get_type ())

struct _PermissionButton {
	GtkGrid parent_instance;
	PermissionButtonPrivate * priv;
	GtkToggleButton* btn_read;
	GtkToggleButton* btn_write;
	GtkToggleButton* btn_exe;
};

struct _PermissionButtonClass {
	GtkGridClass parent_class;
};

struct _PermissionButtonPrivate {
	PermissionsType _permission_type;
	mode_t* vfs_perms;
	gint vfs_perms_length1;
	gint vfs_perms_length2;
};

static gint PermissionButton_private_offset;
static gpointer permission_button_parent_class = NULL;

VALA_EXTERN GType permission_button_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PermissionButton, g_object_unref)
VALA_EXTERN GType permissions_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN PermissionButton* permission_button_new (PermissionsType permission_type);
VALA_EXTERN PermissionButton* permission_button_construct (GType object_type,
                                               PermissionsType permission_type);
VALA_EXTERN void permission_button_update_buttons (PermissionButton* self,
                                       guint32 permissions);
VALA_EXTERN PermissionsType permission_button_get_permission_type (PermissionButton* self);
static void permission_button_set_permission_type (PermissionButton* self,
                                            PermissionsType value);
static GObject * permission_button_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties);
VALA_EXTERN GType permissions_value_get_type (void) G_GNUC_CONST ;
static void permission_button_finalize (GObject * obj);
static GType permission_button_get_type_once (void);
static void _vala_permission_button_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_permission_button_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec);

static inline gpointer
permission_button_get_instance_private (PermissionButton* self)
{
	return G_STRUCT_MEMBER_P (self, PermissionButton_private_offset);
}

PermissionButton*
permission_button_construct (GType object_type,
                             PermissionsType permission_type)
{
	PermissionButton * self = NULL;
	self = (PermissionButton*) g_object_new (object_type, "permission-type", permission_type, NULL);
	return self;
}

PermissionButton*
permission_button_new (PermissionsType permission_type)
{
	return permission_button_construct (TYPE_PERMISSION_BUTTON, permission_type);
}

void
permission_button_update_buttons (PermissionButton* self,
                                  guint32 permissions)
{
	mode_t* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	PermissionsType _tmp1_;
	mode_t _tmp2_;
	mode_t* _tmp5_;
	gint _tmp5__length1;
	gint _tmp5__length2;
	PermissionsType _tmp6_;
	mode_t _tmp7_;
	mode_t* _tmp10_;
	gint _tmp10__length1;
	gint _tmp10__length2;
	PermissionsType _tmp11_;
	mode_t _tmp12_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->vfs_perms;
	_tmp0__length1 = self->priv->vfs_perms_length1;
	_tmp0__length2 = self->priv->vfs_perms_length2;
	_tmp1_ = self->priv->_permission_type;
	_tmp2_ = _tmp0_[(_tmp1_ * _tmp0__length2) + 0];
	if ((permissions & _tmp2_) != ((guint32) 0)) {
		GtkToggleButton* _tmp3_;
		_tmp3_ = self->btn_read;
		gtk_toggle_button_set_active (_tmp3_, TRUE);
	} else {
		GtkToggleButton* _tmp4_;
		_tmp4_ = self->btn_read;
		gtk_toggle_button_set_active (_tmp4_, FALSE);
	}
	_tmp5_ = self->priv->vfs_perms;
	_tmp5__length1 = self->priv->vfs_perms_length1;
	_tmp5__length2 = self->priv->vfs_perms_length2;
	_tmp6_ = self->priv->_permission_type;
	_tmp7_ = _tmp5_[(_tmp6_ * _tmp5__length2) + 1];
	if ((permissions & _tmp7_) != ((guint32) 0)) {
		GtkToggleButton* _tmp8_;
		_tmp8_ = self->btn_write;
		gtk_toggle_button_set_active (_tmp8_, TRUE);
	} else {
		GtkToggleButton* _tmp9_;
		_tmp9_ = self->btn_write;
		gtk_toggle_button_set_active (_tmp9_, FALSE);
	}
	_tmp10_ = self->priv->vfs_perms;
	_tmp10__length1 = self->priv->vfs_perms_length1;
	_tmp10__length2 = self->priv->vfs_perms_length2;
	_tmp11_ = self->priv->_permission_type;
	_tmp12_ = _tmp10_[(_tmp11_ * _tmp10__length2) + 2];
	if ((permissions & _tmp12_) != ((guint32) 0)) {
		GtkToggleButton* _tmp13_;
		_tmp13_ = self->btn_exe;
		gtk_toggle_button_set_active (_tmp13_, TRUE);
	} else {
		GtkToggleButton* _tmp14_;
		_tmp14_ = self->btn_exe;
		gtk_toggle_button_set_active (_tmp14_, FALSE);
	}
}

PermissionsType
permission_button_get_permission_type (PermissionButton* self)
{
	PermissionsType result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_permission_type;
	return result;
}

static void
permission_button_set_permission_type (PermissionButton* self,
                                       PermissionsType value)
{
	PermissionsType old_value;
	g_return_if_fail (self != NULL);
	old_value = permission_button_get_permission_type (self);
	if (old_value != value) {
		self->priv->_permission_type = value;
		g_object_notify_by_pspec ((GObject *) self, permission_button_properties[PERMISSION_BUTTON_PERMISSION_TYPE_PROPERTY]);
	}
}

static GObject *
permission_button_constructor (GType type,
                               guint n_construct_properties,
                               GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PermissionButton * self;
	GtkToggleButton* _tmp0_;
	GtkToggleButton* _tmp1_;
	PermissionsType _tmp2_;
	GtkToggleButton* _tmp3_;
	GtkToggleButton* _tmp4_;
	GtkToggleButton* _tmp5_;
	PermissionsType _tmp6_;
	GtkToggleButton* _tmp7_;
	GtkToggleButton* _tmp8_;
	GtkToggleButton* _tmp9_;
	PermissionsType _tmp10_;
	GtkToggleButton* _tmp11_;
	GtkStyleContext* _tmp12_;
	GtkToggleButton* _tmp13_;
	GtkToggleButton* _tmp14_;
	GtkToggleButton* _tmp15_;
	parent_class = G_OBJECT_CLASS (permission_button_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PERMISSION_BUTTON, PermissionButton);
	_tmp0_ = (GtkToggleButton*) gtk_toggle_button_new_with_label (_ ("Read"));
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->btn_read);
	self->btn_read = _tmp0_;
	_tmp1_ = self->btn_read;
	_tmp2_ = self->priv->_permission_type;
	g_object_set_data_full ((GObject*) _tmp1_, "permissiontype", (gpointer) ((gintptr) _tmp2_), NULL);
	_tmp3_ = self->btn_read;
	g_object_set_data_full ((GObject*) _tmp3_, "permissionvalue", (gpointer) ((gintptr) PERMISSIONS_VALUE_READ), NULL);
	_tmp4_ = (GtkToggleButton*) gtk_toggle_button_new_with_label (_ ("Write"));
	g_object_ref_sink (_tmp4_);
	_g_object_unref0 (self->btn_write);
	self->btn_write = _tmp4_;
	_tmp5_ = self->btn_write;
	_tmp6_ = self->priv->_permission_type;
	g_object_set_data_full ((GObject*) _tmp5_, "permissiontype", (gpointer) ((gintptr) _tmp6_), NULL);
	_tmp7_ = self->btn_write;
	g_object_set_data_full ((GObject*) _tmp7_, "permissionvalue", (gpointer) ((gintptr) PERMISSIONS_VALUE_WRITE), NULL);
	_tmp8_ = (GtkToggleButton*) gtk_toggle_button_new_with_label (_ ("Execute"));
	g_object_ref_sink (_tmp8_);
	_g_object_unref0 (self->btn_exe);
	self->btn_exe = _tmp8_;
	_tmp9_ = self->btn_exe;
	_tmp10_ = self->priv->_permission_type;
	g_object_set_data_full ((GObject*) _tmp9_, "permissiontype", (gpointer) ((gintptr) _tmp10_), NULL);
	_tmp11_ = self->btn_exe;
	g_object_set_data_full ((GObject*) _tmp11_, "permissionvalue", (gpointer) ((gintptr) PERMISSIONS_VALUE_EXE), NULL);
	gtk_grid_set_column_homogeneous ((GtkGrid*) self, TRUE);
	_tmp12_ = gtk_widget_get_style_context ((GtkWidget*) self);
	gtk_style_context_add_class (_tmp12_, GTK_STYLE_CLASS_LINKED);
	_tmp13_ = self->btn_read;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp13_);
	_tmp14_ = self->btn_write;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp14_);
	_tmp15_ = self->btn_exe;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp15_);
	return obj;
}

static void
permission_button_class_init (PermissionButtonClass * klass,
                              gpointer klass_data)
{
	permission_button_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &PermissionButton_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_permission_button_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_permission_button_set_property;
	G_OBJECT_CLASS (klass)->constructor = permission_button_constructor;
	G_OBJECT_CLASS (klass)->finalize = permission_button_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), PERMISSION_BUTTON_PERMISSION_TYPE_PROPERTY, permission_button_properties[PERMISSION_BUTTON_PERMISSION_TYPE_PROPERTY] = g_param_spec_enum ("permission-type", "permission-type", "permission-type", PERMISSIONS_TYPE_TYPE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}

static void
permission_button_instance_init (PermissionButton * self,
                                 gpointer klass)
{
	mode_t* _tmp0_;
	self->priv = permission_button_get_instance_private (self);
	_tmp0_ = g_new0 (mode_t, 3 * 3);
	_tmp0_[0] = S_IRUSR;
	_tmp0_[1] = S_IWUSR;
	_tmp0_[2] = S_IXUSR;
	_tmp0_[3] = S_IRGRP;
	_tmp0_[4] = S_IWGRP;
	_tmp0_[5] = S_IXGRP;
	_tmp0_[6] = S_IROTH;
	_tmp0_[7] = S_IWOTH;
	_tmp0_[8] = S_IXOTH;
	self->priv->vfs_perms = _tmp0_;
	self->priv->vfs_perms_length1 = 3;
	self->priv->vfs_perms_length2 = 3;
}

static void
permission_button_finalize (GObject * obj)
{
	PermissionButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PERMISSION_BUTTON, PermissionButton);
	_g_object_unref0 (self->btn_read);
	_g_object_unref0 (self->btn_write);
	_g_object_unref0 (self->btn_exe);
	self->priv->vfs_perms = (g_free (self->priv->vfs_perms), NULL);
	G_OBJECT_CLASS (permission_button_parent_class)->finalize (obj);
}

static GType
permission_button_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PermissionButtonClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) permission_button_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PermissionButton), 0, (GInstanceInitFunc) permission_button_instance_init, NULL };
	GType permission_button_type_id;
	permission_button_type_id = g_type_register_static (gtk_grid_get_type (), "PermissionButton", &g_define_type_info, 0);
	PermissionButton_private_offset = g_type_add_instance_private (permission_button_type_id, sizeof (PermissionButtonPrivate));
	return permission_button_type_id;
}

GType
permission_button_get_type (void)
{
	static volatile gsize permission_button_type_id__once = 0;
	if (g_once_init_enter (&permission_button_type_id__once)) {
		GType permission_button_type_id;
		permission_button_type_id = permission_button_get_type_once ();
		g_once_init_leave (&permission_button_type_id__once, permission_button_type_id);
	}
	return permission_button_type_id__once;
}

static void
_vala_permission_button_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	PermissionButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PERMISSION_BUTTON, PermissionButton);
	switch (property_id) {
		case PERMISSION_BUTTON_PERMISSION_TYPE_PROPERTY:
		g_value_set_enum (value, permission_button_get_permission_type (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_permission_button_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec)
{
	PermissionButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PERMISSION_BUTTON, PermissionButton);
	switch (property_id) {
		case PERMISSION_BUTTON_PERMISSION_TYPE_PROPERTY:
		permission_button_set_permission_type (self, g_value_get_enum (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

